// Trying to count up by one to epsilon

#define __HEADER__
#include <stdlib.h>
#include "ord_fnc.c"

int Depth;
int Omega;


void nSpaces (int n)
{
	for (int i = 1; i <= n; ++i) printf (" ");
}


void threeDots (int depth)
{
	printf ("\n");
     nSpaces (depth);
     printf ("...");
}

void markMissing (const Ord alpha, const Ord last)
{
    	Ord successor = last;
	successor += 1;
	if (alpha > successor)
     {
//		printf (",  ");
//		successor.PrintOn (stdout);
		printf (", ...");
     }
}

int lastWasThreeDots = 0;


void recurse (const Ord alpha, Ord *min, int depth)
{
     if (depth > Depth) return;
     if (isLimit (alpha))
     {
     	for (int n = 1; n < Omega; ++n)
          {
               recurse (AlphaTerm (alpha, n), min, depth + 1);
          }
          Ord omegath = AlphaTerm (alpha, Omega);
          if (omegath > *min && depth < Depth)
          {
          	markMissing (omegath, *min);
	          threeDots (depth + 1);
               lastWasThreeDots = 1;
          }
     }
     if (alpha > *min)
     {
          if (!lastWasThreeDots) markMissing (alpha, *min);
	     printf ("\n");
          nSpaces (depth);
	    	alpha.PrintOn (stdout);
          *min <<= alpha;
          lastWasThreeDots = 0;
     }
}


void usage ()
{
	printf ("\n\nUsage: ORDEPS n w");
     printf ("\n  n = recursion depth > 0");
     printf ("\n  w = omega approximation > 2");
     printf ("\n");
}


int getParams (const char **argv, int *arg1, int *arg2)
{
	if (argv [3] || !argv [1] || !argv [2])
     {
     	usage ();
          return 0;
     }
     *arg1 = atoi (argv [1]);
     *arg2 = atoi (argv [2]);
     if (!*arg1 || !*arg2)
     {
     	usage ();
          return 0;
     }
     return 1;
}



void main (int, const char **argv)
{
	Ord low = 0;
	if (!getParams (argv, &Depth, &Omega)) return;
     printf ("\n 0");
	recurse (EPSILON, &low, 0);
     printf (".\n");
}